unit variab;

interface

TYPE
  pt = record                           { maakt een eenvoudige behandeling}
    ofs,sgm  :  word;                   { van de pointers mogelijk    }
  end;

  Effect_Type = record
     p  : pointer;
     l  : longint;
     sr : word;
   end;

  Param_Table = record
    mult  : word;
    Speed : word;
    bgr   : word;
    Ab    : integer;
   end;
TYPE vocheader = record
       Identstr : array[0..19] of char;
       Sampoff  : word;
       Verslo   : Byte;
       Vershi   : Byte;
       Ident    : word;
     end;

     Voiceblock = record
       Ident     : byte;
       Lengte_lo : word;
       Lengte_hi : byte;
       SR        : byte;
       Pack      : byte;
     end;



CONST block_activ : byte = 1;
  Incfacts : array[1..99] of longint =
    ( $0021E7,$0023EB,$00260E,$002851,$002AB7,$002D41,$002FF2,$0032CC,
      $0035D1,$003904,$003C68,$004000,$0043CE,$0047D6,$004C1C,$0050A2,
      $00556E,$005A82,$005FE4,$006598,$006BA2,$007209,$0078D0,$007FFF,
      $00879C,$008FAC,$009837,$00A144,$00AADB,$00B504,$00BFC8,$00CB2F,
      $00D744,$00E411,$00F1A1,$00FFFF,$010F39,$011F5A,$013070,$01428A,
      $0155B8,$016A09,$017F91,$01965F,$01AE89,$01C823,$01E343,$01FFFF,
      $021E72,$023EB3,$0260DF,$028514,$02AB6F,$02D413,$02FF21,$032CC0,
      $035D14,$039047,$03C686,$03FFFF,$043CE4,$047D66,$04C1BF,$050A29,
      $0556E0,$05A827,$05FE43,$06597F,$06BA27,$07208F,$078D0D,$07FFFF,
      $0879C7,$08FACC,$09837E,$0A1451,$0AADC0,$0B504F,$0BFC87,$0CB2FF,
      $0D744F,$0E411F,$0F1A1C,$0FFFFF,$10F38F,$11F59A,$1306FE,$1428A3,
      $155B81,$16A09E,$17F910,$1965FE,$1AE89F,$1C823D,$1E3438,$1FFFFF,
      $21E71E, $23EB35,$260DFC
    );

  outfading : boolean = false;
  outvolume : byte = 63;
  msp : longint = 0;
  MODDATGROOTTE : longint = 0;
  filter_activ : boolean = false;
  balance : byte = 12;
  Mastervolume : byte = 29;
  Startport : word = $200;
  Endport   : word = $280;
  playspeed : byte = 6;

  DETECT = 55555;
  Samfreq : word = 22;
  force_mono : boolean = false;
  force_sb : boolean = false;
  force_irq : boolean = false;
  force_dma : boolean = false;
  force_base : boolean = false;
  PC    = 0;
  AMIGA = 1;
  m669 : boolean = false;
  interrupt_gevonden : boolean = false;
  interrupt_check : boolean = false;
  Choose_lower_freq : boolean = false;
  timer_per_second  : word = 50;          { aantal interrupts per Sec. }
  Sampling_Frequentie : word = 10000;     { de samplingfreq.; default  }
  in_retrace        : boolean = false;    { in retrace-procedure ?     }
  dsp_irq        : byte = $5;             { interrupt van de SB, waarde}
                                          { wordt door de init-routine }
                                          {  veranderd                 }
  dma_ch            : byte = 1;           { DMA Chanel, standaard      }
                                          { = 1, op SB 16 ASP ook ande-}
                                          { re waarden mogelijk ...    }
  dsp_adr           : word = $220;        { base-adres van de DSP.     }
                                          { waarde wordt door de init- }
                                          { routine veranderd          }
  SbVersMin         : BYTE = 0;           { de versie - ident          }
  SbVersMaj         : BYTE = 0;
  STEREO            : BOOLEAN = false;    { stereo-weergave            }
  SbRegDetected     : BOOLEAN = FALSE;    { normale SB aanwezig ?      }
  IRQDetected       : BOOLEAN = FALSE;
  SbRegInited       : BOOLEAN = FALSE;
  SbProDetected     : BOOLEAN = FALSE;    { SB Pro aanwezig ?          }
  SbProInited       : BOOLEAN = FALSE;
  Sb16Detected      : BOOLEAN = FALSE;    { SB 16 ASP aanwezig ?       }
  Sb16Inited        : BOOLEAN = FALSE;
  MixerDetected     : BOOLEAN = FALSE;    { zo ja, kaart >= SB Pro     }
  OldTimerInt                 = $71;      { originele int-routine van  }
                                          { omgelegde Timer - Int.     }
  Stemmen           : integer = 4;        { aantal stemmen in          }
                                          { MOD-File                   }
  Modoctaaf : array[1..70] of word =
   (
    1712,1616,1525,1440,1359,1283,1211,   { de waarden in modoctaaf    }
    1143,1078,961,907,856,808,763,720,    { komen overeen met die in de}
    679,641,605,571,539,509,480,453,428,  { MOD-file als toonhoogtes   }
    404,381,360,340,321,303,286,270,254,  { opgeslagen waarden         }
    240,227,214,202,191,180,170,160,151,
    143,135, 127,120,113,107,101,95,90,
    85,80,76,71,67,64,60,57,
    54,51,48,45,43,40,38,36,34,32,30);

{ PermUp_1          : byte = 0;           { Portamento Up van de stem ? }
{ PermUp_2          : byte = 0;
 PermUp_3           : byte = 0;
 PermUp_4           : byte = 0;
 PermUp_5           : byte = 0;
 PermUp_6           : byte = 0;
 PermUp_7           : byte = 0;
 PermUp_8           : byte = 0;
 PermDo_1           : byte = 0;            { Portamento Down van de stem }
 {PermDo_2           : byte = 0;
 PermDo_3           : byte = 0;
 PermDo_4           : byte = 0;
 PermDo_5           : byte = 0;
 PermDo_6           : byte = 0;
 PermDo_7           : byte = 0;
 PermDo_8           : byte = 0;
 PermNk1            : word = 0;
 PermNk2            : word = 0;
 PermNk3            : word = 0;
 PermNk4            : word = 0;
 PermNk5            : word = 0;
 PermNk6            : word = 0;
 PermNk7            : word = 0;
 PermNk8            : word = 0;}

 AUTO = 9999;                              { Ident tbv auto detection }
 ON   = true;
 OFF  = false;
 playeffect : boolean = false;
 effectvolume : word = 7;
 converteff    : byte = 0;
 sensib : real = 0.9;

 dma_page : array[0..3] of byte = ($87,$83,$81,$81);
 dma_adr  : array[0..3] of byte = (0,2,4,6);
 dma_wc   : array[0..3] of byte = (1,3,5,7);

 sb16_outputlengte : word = 0;
 laatste_weergave : boolean = false;

VAR
 Oldintteller : word;
 efi : file;
 outfile : file;
{ ModPara : array[0..64] of Param_Table;}
 blockgrootte        : word;               { omvang geluidsbuffer       }
 dsp_rdy_sb16        : boolean;            { flag tbv einde transfer    }
                                           { van de data via DMA        }
 SbVersStr           : string[5];          { de SB-versie als string    }
 Speed               : word;               { weergavesnelheid           }
 oldInt              : pointer;            { tbv beveiliging van de SB  }
                                           { voor DMA-transfer benodigde}
                                           { interrupts                 }
 irqmsk              : byte;               { tbv interrupthandling      }
 Meng_proc           : pointer;            { pointer naar routines, die }
 nmw_proc            : pointer;            { afhankelijk aantal aanwezige}
 binnen_proc         : pointer;            { stemmen uitgevoerd worden  }
 Noot_Uitslag        : array[1..8]         { tijd sedert laatste start  }
                       of integer;
 Rm_Song             : Array[1..64,1..8,   { een pattern                }
                         1..4] of Byte;
 rm                  : array[0..128]       { de afzonderlijke patterns  }
                       of pointer;
 Song                : array[1..128]       { arrangement van de song    }
                       of byte;
 blk                 : pointer;            { pointer naar de databuffer }
 inst        : array[1..8] of pointer;
 Samp                : Array[1..64]        { array met pointers naar de }
                       of pointer;         { samples                    }
 Sam_l               : Array[1..64]        { de lengte van het sample   }
                       of word;
 loop_s              : array[1..64]        { Loop-Start van het sample  }
                       of word;
 loop_l              : array[1..64]        { Loop-Lengte van het sample }
                       of word;
 i1,i2,i3,i4,                              { pointer naar actieve sample}
 i5,i6,i7,i8         : pt;                 { in "pt"-formaat            }
 inl           : array[1..8] of word;
 inp           : array[1..8] of word;
 i                   : word;
 mlj                 : word;               { loopteller, actueel        }
                                           { pattern                    }
 mli                 : word;               { loopteller, actuele        }
                                           { regel in het pattern       }
{ Vk1,Vk2,Vk3,                             { deel voor komma van factor,}
{ Vk4,Vkh,Vk5,                             { waarmee de pos in de sample}
{ Vk6,Vk7,Vk8         : word;              { verhoogd moeten worden     }
{ Nk1,Nk2,Nk3,                             { deel voor komma van factor,}
{ Nk4,Nkh,Nk5,                             { waarmee de pos in de sample}
{ Nk6,Nk7,Nk8         : byte;              { verhoogd moeten worden     }
{ Dif1,Dif2,Dif3,
 Dif4,Dif5,Dif6,
 Dif7,Dif8           : byte;
 Difb1,Difb2,Difb3,
 Difb4,Difb5,Difb6,
 Difb7,Difb8           : byte;}
{ Inst1vk             : word;              { wijst naar actueel sample- }
{ Inst2vk             : word;              { byte in de data            }
{ Inst3vk             : word;
 Inst4vk             : word;
 Inst5vk             : word;
 Inst6vk             : word;
 Inst7vk             : word;
 Inst8vk             : word;
 Inst1nk             : byte;               { deel achter komma van sample}
{ Inst2nk             : byte;}             { byte                        }
{ Inst3nk             : byte;
 Inst4nk             : byte;
 Inst5nk             : byte;
 Inst6nk             : byte;
 Inst7nk             : byte;
 Inst8nk             : byte;}
 In_St       : array[1..8] of byte;
 sam_aantal             : byte;            { aantal samples             }
 pat_aantal             : byte;            { aantal patterns            }
 m_played            : boolean;            { muziek moet gespeeld ???   }
 Sound_Slepen     : word;                  { aantal stappen in de       }
                                           { mengroutine                }
 Sampling_Rate       : byte;               { aan DSP overgedragen waarde}
                                           { van de frequentie          }
 mod_name            : string;             { DOS-naam MOD-bestand       }
 tpw                 : integer;            { transposer - waarde        }
 loop_pos            : word;               { loopvar., van 0 tot speed  }
 phase_1,                                  { de twee fasen van de inter-}
 phase_2             : boolean;            { rupt-mengroutine           }
 Sampel1,Sampel2,                          { het actieve sample         }
 Sampel3,Sampel4,
 Sampel5,Sampel6,
 Sampel7,Sampel8     : pointer;
 Sagr1,Sagr2,                           { omvang van het actieve sample}
 Sagr3,Sagr4,
 Sagr5,Sagr6,
 Sagr7,Sagr8         : word;
 mautodet            : boolean;         { indien true wordt de speed }
                                        { opgave in de song gebruikt }
 modmultiply         : word;            { Speed-opgave in song * Mod-}
                                        { multiply = Speed           }
 mloop               : boolean;         { indien true begint de MOD  }
                                        { na het afspelen van voren af}
 periodiek_onderbreken : pointer;       { pointer naar Stop_Procedure}
                                        { tbv weergave               }
 music_uit           : boolean;         { indien true wordt geen     }
                                        { muziek gespeeld ...        }
 Nootvol1,Nootvol2,                     { luidsterkte afzonderlijke  }
 Nootvol3,Nootvol4,                     { kanalen                    }
 Nootvol5,Nootvol6,
 Nootvol7,Nootvol8     : byte;
 Pnk           : array[1..8] of byte;
 Old_TTeller        : word;             { tbv syncronisatie van de   }
                                        { oude timer interrupts      }
 Dma_Teller         : integer;          { tbv afvangen van DMA_Ready }
                                        { interrupt                  }
 dma_afbreken         : integer;        { waarde afbreken  Dma_Teller}
 mod_terminated      : boolean;         { Mod-weergave afgelopen     }
 ls    : array[1..8] of word;
 ll     : array[1..8] of word;
 Eff  : array[1..8] of byte;
 Songname            : string[20];      { naam van de MOD-file       }
 Instnamen           : array[1..31]     { namen van de instrumenten  }
                       of string[22];
 Inst_vol            : array[1..31]
                       of byte;
 Songlengte          : byte;            { lengte van de song         }
 Secteller          : word;             { tbv tijdberekening         }
 Speelsec,Speelmin     : byte;          { speelduur van de song      }
 Pattgrootte         : integer;         { patterngrootte voor modtype}
 XMSMaxFree          : word;            { Max. vrij XMS-geheugen     }
 MinXms              : word;            { indien XMSMaxFree < MinXms }
 xmsHandles             : array[1..32]
                       of word;         { handles voor XMS           }

 soundeff : pointer;
 effectgrootte : word;
 effectposi : word;
 Effvk      : word;
 Effnk      : byte;
 Effistvk   : word;
 Effistnk   : byte;
 Effect : pt;
 Effect_wissen : boolean;
 toonhoogtewaarde : byte;

{ tempolist : array[1..128] of byte;
 breaklist : array[1..128] of byte;}
 doel : pt;                             { afspeelbuffer in pt-formaat}
 Modp  : pointer;                       { pointer naar Rm_Song       }
 noot1,noot2,                           { actieve instrument van de  }
 noot3,noot4,                           { stem                       }
 noot5,noot6,
 noot7,noot8 :byte;

 Fadepos1,fadepos2,
 fadepos3,fadepos4,
 fadepos5,fadepos6,
 fadepos7,fadepos8 : word;

 intback : pointer;
 port21 : byte;

 vocf : file;
 fgr : longint;
 blk1,blk2 : pointer;
 voch : vocheader;
 vblock : voiceblock;
 intpointer : pointer;
 dsp_rdy_voc : boolean;
 blockgr : word;
 PLAYING_MOD : boolean;
 PLAYING_VOC : boolean;
 dummarray : array[1..20] of byte;
 lastone : boolean;
 VOC_READY : boolean;
 inread : array[1..25] of byte;
 vocsstereo : boolean;
 Mod_afgelopen : boolean;

implementation

begin;
end.



