{$G+,I-,X+,A+,N+}
{$M $4000,0,375000}
PROGRAM WRITERV2;

uses Cybunit,dos,crt,variab,mod_sb,gp15;

type
   memarray=array[1..64000] of byte;
   Dirtype = record
           name:string[12];
           Attr:byte;
           end;
   Dirarray=array[0..1000] of Dirtype;

var
   WR20_soundcard:byte;
   oldstxpos,oldstypos,stxpos,stypos:array[0..500] of word;
   xnr,ynr,znr:array[0..500] of integer;
   stuff:array[0..1002] of integer;
   logo:^memarray;
   DirStuff:^Dirarray;
   DirInfo:SearchRec;
   MyData:file of byte;
   letter:file of byte;
   x,i:integer;
   l:longint;
   richting:Shortint;
   a,r,g,b,c,item,fade:byte;
   y,pogo:word;
   stop:boolean;
   oldcursor:array[1..126] of byte;
   extrabyte:array[1..20] of byte;

const cursor:array[0..15] of byte =(
          $00,              {0000 0000}
          $00,              {0000 0000}
          $00,              {0000 0000}
          $00,              {0000 0000}
          $7E,              {0111 1110}
          $7E,              {0111 1110}
          $66,              {0110 0110}
          $66,              {0110 0110}
          $66,              {0110 0110}
          $66,              {0110 0110}
          $7E,              {0111 1110}
          $7E,              {0111 1110}
          $00,              {0000 0000}
          $00,              {0000 0000}
          $00,              {0000 0000}
          $00);             {0000 0000}

label init,Endproggy;

Procedure Erasestars;
begin
for i:=0 to 500 do
if GetPixel(oldstxpos[i],oldstypos[i]) IN [216..248] then
     Putpixel(Oldstxpos[i],oldstypos[i],0);
end;

PROCEDURE Starfield;

          PROCEDURE Newstar;
          begin
           if pogo > 1000 then
            pogo := 0
           else inc(pogo);
           xnr[i]:=stuff[pogo];
           ynr[i]:=stuff[pogo+1];
           znr[i]:=512;
           stxpos[i]:=639;
           stypos[i]:=400;
           c:=0;
          end;

BEGIN
for i:=0 to 250 do
  begin
   if GetPixel(oldstxpos[i],oldstypos[i]) IN [216..248] then
     Putpixel(Oldstxpos[i],oldstypos[i],0);

   dec(znr[i]);
   if znr[i] < 1 then Newstar;

   stxpos[i] := (xnr[i] div znr[i])+320;
   stypos[i] := (ynr[i] div znr[i])+250;
   c:=(znr[i] div 16)+216;
   if stxpos[i] < 4 then Newstar;
   if stxpos[i] > 636 then Newstar;
   if stypos[i] < 100 then Newstar;
   if stypos[i] > 399 then Newstar;
   if NOT(GetPixel(stxpos[i],stypos[i]) in [200..215]) then
    Putpixel(stxpos[i],stypos[i],c);
   oldstxpos[i]:=stxpos[i];
   oldstypos[i]:=stypos[i];
  end
end;

Procedure PlaceBlock(x,y:word;lengt:byte);
var d,e:byte;
begin
for d:=0 to 15 do
for e:=0 to lengt do
    if NOT(Getpixel(x+e,y+d) in [201..216]) then
       Putpixel(x+e,y+d,200);
end;

Procedure EraseBlock(x,y:word;lengt:byte);
var d,e:byte;
begin
for d:=0 to 15 do
for e:=0 to lengt do
    if Getpixel(x+e,y+d)=200 then
       Putpixel(x+e,y+d,0);
end;

Procedure ClearField;
var q:byte;
    t:word;
begin
for q:=1 to 5 do
   begin
   bank(q);
   for t:=0 to 65535 do
       mem[$0A000:t]:=0;
   end
end;

Procedure displayWriterLogo;
var kleuren:word;
    waarde:byte;
begin
ClsSVGA;
{* load logo colours *}
l:=20*4096+64768;
Seek(MyData,l);
Port[968]:=0;
for kleuren:=1 to 600 do
  begin
  Read(Mydata,waarde);
  Port[969]:=waarde;
  end;
{* load logo into vga-mem *}
l:=20*4096+64768+768;
Seek(MyData,l);
Bank(0);
for kleuren:=1 to 64000 do
  begin
  Read(MyData,waarde);
  logo^[kleuren]:=waarde;
  end;
for kleuren:=1 to 64000 do
  mem[$0A000:kleuren-1]:=logo^[kleuren];

end;

Procedure PlaceCursor(atx,aty:byte);
var xshift,yshift,chrval:byte;
    pix:boolean;
    xpxl,ypxl:word;
begin
xpxl:=8*atx;
ypxl:=16*aty;
for yshift:=0 to 15 do
  begin
  chrval:=cursor[yshift];
  for xshift:=0 to 7 do
   begin
   asm
    clc
    mov pix,0
    shl chrval,1
    jnc @niet
    mov pix,1
    @niet:
   end;
   if pix then
    Putpixel(xpxl+xshift,ypxl+yshift,200)
   else
    Putpixel(xpxl+xshift,ypxl+yshift,0);
   end
  end
end;

Procedure Goldflush;
var c,r,g,b,oldr,oldg,oldb:byte;
begin
Port[967]:=249;
oldr:=Port[969];
oldg:=Port[969];
oldb:=Port[969];
for c:=249 to 254 do
  begin
  Port[967]:=c+1;
  r:=Port[969];
  g:=Port[969];
  b:=Port[969];
  Port[968]:=c;
  Port[969]:=r;
  Port[969]:=g;
  Port[969]:=b;
  end;
Port[968]:=255;
Port[969]:=oldr;
Port[969]:=oldg;
Port[969]:=oldb;
Port[968]:=200;
Port[969]:=oldr;
Port[969]:=oldg;
Port[969]:=oldb;
end;

Procedure MoveScreen1up;
var i,j:word;
    c:byte;
begin
{* Erase stars *}
EraseStars;
{* move all pixels van 16*10 -> 16*24 naar 16*9 }
Bank(1);
asm
push es
push ds
push si
push di
mov ax,0A000h
mov es,ax
mov ds,ax
mov si,36864
mov di,36864-16*640
mov cx,14080
rep movsw
pop di
pop si
pop ds
pop es
end;
for i:=204 to 221 do
 for j:=0 to 639 do
  begin
   c:=Getpixel(j,i);
   Putpixel(j,i-16,c);
  end;
Bank(2);
asm
push es
push ds
push si
push di
mov ax,0A000h
mov es,ax
mov ds,ax
mov si,11008
mov di,11008-16*640
mov cx,27200
rep movsw
pop di
pop si
pop ds
pop es
end;
Bank(3);
for i:=307 to 323 do
 for j:=0 to 639 do
  begin
   c:=Getpixel(j,i);
   Putpixel(j,i-16,c);
  end;
asm
push es
push ds
push si
push di
mov ax,0A000h
mov es,ax
mov ds,ax
mov si,10112
mov di,10112-16*640
mov cx,29696
rep movsw
pop di
pop si
pop ds
pop es
end;
{* Clear last line *}
for i:=49152 to 65535 do
   mem[$0A000:i]:=0;
end;

Procedure Clear;
var x:word;
    b:byte;
begin
Bank(1);
for x:=26624 to 65535 do
   mem[$0A000:x]:=0;
for b:=2 to 3 do
  begin
  Bank(b);
  for x:=0 to 65535 do
    mem[$0A000:x]:=0;
  end
end;

Procedure Getoldcursor(cx,cy:byte);
var pixel,chb,plusx,plusy:byte;
    xpxl,ypxl:word;
begin
xpxl:=cx*8;
ypxl:=cy*16;
chb:=1;
for plusy:=0 to 15 do
  for plusx:=0 to 7 do
     begin
     pixel:=GetPixel(xpxl+plusx,ypxl+plusy);
     if pixel in [216..248] then
       oldcursor[chb]:=0
     else
       oldcursor[chb]:=pixel;
     inc(chb);
     end
end;

Procedure Putoldcursor(cx,cy:byte);
var chb,plusx,plusy:byte;
    xpxl,ypxl:word;
begin
xpxl:=cx*8;
ypxl:=cy*16;
chb:=1;
for plusy:=0 to 15 do
  for plusx:=0 to 7 do
     begin
     Putpixel(xpxl+plusx,ypxl+plusy,oldcursor[chb]);
     inc(chb);
     end
end;

Procedure MakeLetter;
var name:string[12];
    pointstr:shortint;
    val,oldx,oldy,kleur,sc,kr:byte;
    x,y:shortint;
    esc,doe,back,starsweg:boolean;

begin
val:=0;
name:='            ';
Clearfield;
WrStr(20,20,'Please give a valid filename (max 8.3) : ',209);
pointstr:=1;
repeat
Starfield;
WaitRetrace;
Getchar(sc,kr);
case kr of
 08: if pointstr>1 then
        begin
        dec(pointstr);
        name[pointstr]:=' ';
        WrSVGA(34+pointstr,21,32,209);
        end;

  33..126: if pointstr<13 then
              begin
               name[pointstr]:=Chr(kr);
               WrSVGA(34+pointstr,21,kr,209);
               inc(pointstr);
               end;
end;
until kr=13;
name[pointstr]:=CHR(0);
{* Make Letter-file *}
Assign(Letter,name);
Rewrite(Letter);
{* Display writer-logo *}
DisplayWriterLogo;
{* change starfield colours to magenta *}
kr:= 63;
FOR sc := 216 TO 248 do
begin
port[968]:=sc;
port[969]:=kr;
port[969]:=0;
port[969]:=kr*3 div 7;
dec(kr);
dec(kr);
end;
Bank(1);
WrStr(36,7,'+ Write +',210);
{---------------------------Vanaf hier main-routine-------------------------}
x:=0;
y:=8;
oldx:=0;
oldy:=8;
for x:=1 to 126 do
  oldcursor[x]:=0;
kleur:=215;
esc:=false;
back:=false;
starsweg:=false;
PlaceCursor(0,9);
repeat
{haal karakter op}
GetChar(sc,kr);
if sc>0 then
 begin
 doe:=true;
 write(Letter,sc);
 write(Letter,kr);
 end
 else doe:=false;
{zie wat karakter is en..
     check for -color codes (F1-F10)
               -return
               -gewone karakters
               -pijltestoetsen!  }
case sc of
     59 : begin kleur:=201;doe:=false; end;    {F1 to...     }
     60 : begin kleur:=202;doe:=false; end;
     61 : begin kleur:=203;doe:=false; end;
     62 : begin kleur:=204;doe:=false; end;
     63 : begin kleur:=205;doe:=false; end;
     64 : begin kleur:=215;doe:=false; end;
     65 : begin kleur:=207;doe:=false; end;
     66 : begin kleur:=208;doe:=false; end;
     67 : begin kleur:=209;doe:=false; end;
     68 : begin kleur:=210;doe:=false; end;
     133 : begin kleur:=211;doe:=false; end;
     134 : begin kleur:=212;doe:=false; end;  { F12 ! }
     72 : begin oldy:=y;dec(y);doe:=false; end;      {pijl naar boven}
     80 : begin oldy:=y;inc(y);doe:=false; end;      {pijl naar beneden}
     75 : begin oldx:=x;dec(x);doe:=false; end;      {pijl naar links}
     77 : begin oldx:=x;inc(x);doe:=false; end;      {pijl naar rechts}
     28 : begin x:=0;inc(y);doe:=false; end; {returntoets!}
     14 : begin dec(x);kr:=32;back:=true;end;  {backspace}
      1 : begin esc:=true;doe:=false;end;
     15 : begin x:=x+5;doe:=false;end;  {tab}
     71 : begin Clear;x:=0;y:=9;doe:=false;end; {home}
end;

{* check borders *}
if x>79 then begin x:=0;inc(y); end;
if x<0 then begin x:=79;dec(y);end;
if y>24 then begin MoveScreen1up;y:=24;oldy:=23;end;
if y<9 then y:=9;

{* write char *}
if doe then wrSVGA(x,y,kr,kleur);

{* place/erase cursor *}
case sc of
   28,15: begin
           PlaceCursor(x,y);
           WrSVGA(oldx,oldy,32,0);
          end;
   71: PlaceCursor(x,y);
   14: begin
        PlaceCursor(x,y);
        WrSVGA(oldx,oldy,32,0);
        back:=false;
       end;
   72,80 : begin {pijl up,down}
            Putoldcursor(x,oldy);
            Getoldcursor(x,y);
            PlaceCursor(x,y);
           end;
   75,77 : begin {pijl left,right}
            Putoldcursor(oldx,oldy);
            Getoldcursor(x,y);
            PlaceCursor(x,y);
           end;
  else
    if doe then
       begin
       inc(x);
        if x>79 then
         begin
         Getoldcursor(0,y+1);
         PlaceCursor(0,y+1);
         end
        else
         begin
         Getoldcursor(x,y);
         PlaceCursor(x,y);
         end
       end
end;

if val=4 then
  begin
  Goldflush;
  val:=0;
  end
else
  inc(val);
starfield;
WaitRetrace;
oldx:=x;
oldy:=y;
until esc;
Close(Letter);
end;


Function GetNameFromDirectory(extens:string):PathStr;
var beginfilenr,endfilenr,filenr,holdvalue,maxitem:integer;
    ThaName:PathStr;
    Path: PathStr;
    fname: NameStr;
    Dir: DirStr;
    ext: ExtStr;
    sc,kr:byte;
    voormod,exitthissub:boolean;
label anotherdir,weghieruitdezeroutine;
begin
if (extens='mod') then voormod:=true else voormod:=false;
ThaName:='                   ';
path:=FExpand(Paramstr(0));
FSplit(Path,Dir,fname,ext);
anotherdir:
filenr:=0;
Clearfield;
WrStr(1,7,'Directory of '+Dir+'*.'+extens,211);
{* alle filenames in geheugen laden (max. 1000) *}
FindFirst(Dir+'*.*', $30, DirInfo);
if not voormod then
    begin
     While ((DosError = 0) and (filenr < 1000)) do
       begin
       DirStuff^[filenr].name:=DirInfo.Name;
       DirStuff^[filenr].Attr:=DirInfo.Attr;
       FindNext(DirInfo);
       inc(filenr);
       end
    end;
if voormod then
    begin
     While ((DosError = 0) and (filenr < 1000)) do
       begin
       if ((DirInfo.Attr=$10) or (pos('.MOD',DirInfo.name)>0)) then
             begin
             DirStuff^[filenr].name:=DirInfo.Name;
             DirStuff^[filenr].Attr:=DirInfo.Attr;
             inc(filenr);
             end;
       FindNext(DirInfo);
       end
    end;
maxitem:=filenr;
filenr:=0;
{* display files in 4 columns (each column= 10 files) *}
while ((filenr<60) and (filenr<maxitem)) do
      begin
      if DirStuff^[filenr].attr=$10 then
        WrStr(4+(filenr div 15)*20,9+(filenr mod 15),'<'+DirStuff^[filenr].name+'>',203)
      else
        WrStr(4+(filenr div 15)*20,9+(filenr mod 15),DirStuff^[filenr].name,209);
      inc(filenr);
      end;
{* place cursor on first element and wait for key *}
{* set filename = (first filename loaded into array) *}
PlaceBlock(3*8,9*16,14*8);
filenr:=0;
beginfilenr:=0;
endfilenr:=59;
{* Getkey and move block around and also increase filenr accordingly *}
exitthissub:=false;
repeat
Starfield;
WaitRetrace;
GetChar(a,b);
case a of
       01 : exitthissub:=true;
{dwn}  80 : Begin
             inc(filenr);
             if filenr>(maxitem-1) then filenr:=maxitem-1;
             if ((filenr-beginfilenr)>59)then
                 begin
                 Clear;
                 beginfilenr:=beginfilenr+15;
                 endfilenr:=endfilenr+15;
                 filenr:=beginfilenr;
                 while (not(filenr>endfilenr) and (filenr<maxitem)) do
                  begin
                  if DirStuff^[filenr].attr=$10 then
      WrStr(4+((filenr-beginfilenr) div 15)*20,9+((filenr-beginfilenr) mod 15),'<'+DirStuff^[filenr].name+'>',203)
                  else
      WrStr(4+((filenr-beginfilenr) div 15)*20,9+((filenr-beginfilenr) mod 15),DirStuff^[filenr].name,209);
                  inc(filenr);
                  end;
                 filenr:=endfilenr-14;
                 PlaceBlock((3+((filenr-beginfilenr) div 15)*20)*8,(9+((filenr-beginfilenr) mod 15))*16,14*8);
                 end
             else
                 case (filenr-beginfilenr) of
                      15 : begin
                            Eraseblock(3*8,23*16,14*8);
                            Placeblock(23*8,9*16,14*8);
                           end;
                      30 : begin
                            Eraseblock(23*8,23*16,14*8);
                            Placeblock(43*8,9*16,14*8);
                           end;
                      45 : begin
                            Eraseblock(43*8,23*16,14*8);
                            Placeblock(63*8,9*16,14*8);
                           end;
                    else
                        begin
                        EraseBlock((3+((filenr-beginfilenr) div 15)*20)*8,(9+((filenr-beginfilenr-1) mod 15))*16,14*8);
                        PlaceBlock((3+((filenr-beginfilenr) div 15)*20)*8,(10+((filenr-beginfilenr-1) mod 15))*16,14*8);
                        end
                 end;
             end;
{up}   72 : Begin
            dec(filenr);
            if (filenr<0) then filenr:=0;
            if ((filenr-beginfilenr)<0) then
                 begin
                 Clear;
                 beginfilenr:=beginfilenr-15;
                 endfilenr:=endfilenr-15;
                 filenr:=beginfilenr;
                 while (not(filenr>endfilenr) and (filenr<maxitem)) do
                  begin
                  if DirStuff^[filenr].attr=$10 then
      WrStr(4+((filenr-beginfilenr) div 15)*20,9+((filenr-beginfilenr) mod 15),'<'+DirStuff^[filenr].name+'>',203)
                  else
      WrStr(4+((filenr-beginfilenr) div 15)*20,9+((filenr-beginfilenr) mod 15),DirStuff^[filenr].name,209);
                  inc(filenr);
                  end;
                 filenr:=beginfilenr+14;
                 PlaceBlock((3+((filenr-beginfilenr) div 15)*20)*8,(9+((filenr-beginfilenr) mod 15))*16,14*8);
                 end
            else
                 case (filenr-beginfilenr) of
                      14 : begin
                            Placeblock(3*8,23*16,14*8);
                            Eraseblock(23*8,9*16,14*8);
                           end;
                      29 : begin
                            Placeblock(23*8,23*16,14*8);
                            Eraseblock(43*8,9*16,14*8);
                           end;
                      44 : begin
                            Placeblock(43*8,23*16,14*8);
                            Eraseblock(63*8,9*16,14*8);
                           end;
                    else
                        begin
                        EraseBlock((3+((filenr-beginfilenr) div 15)*20)*8,(10+((filenr-beginfilenr) mod 15))*16,14*8);
                        PlaceBlock((3+((filenr-beginfilenr) div 15)*20)*8,(9+((filenr-beginfilenr) mod 15))*16,14*8);
                        end
                 end
            end;

{rght} 77 : begin
            filenr:=filenr+15;
            if filenr>(maxitem-1) then filenr:=filenr-15;
            if ((filenr-beginfilenr)>59)then
                 begin
                 Clear;
                 holdvalue:=filenr;
                 beginfilenr:=beginfilenr+15;
                 endfilenr:=endfilenr+15;
                 filenr:=beginfilenr;
                 while (not(filenr>endfilenr) and (filenr<maxitem)) do
                  begin
                  if DirStuff^[filenr].attr=$10 then
      WrStr(4+((filenr-beginfilenr) div 15)*20,9+((filenr-beginfilenr) mod 15),'<'+DirStuff^[filenr].name+'>',203)
                  else
      WrStr(4+((filenr-beginfilenr) div 15)*20,9+((filenr-beginfilenr) mod 15),DirStuff^[filenr].name,209);
                  inc(filenr);
                  end;
                 filenr:=holdvalue;
                 PlaceBlock((3+((filenr-beginfilenr) div 15)*20)*8,(9+((filenr-beginfilenr) mod 15))*16,14*8);
                 end
            else
                begin
                EraseBlock((3+((filenr-beginfilenr-15) div 15)*20)*8,(9+((filenr-beginfilenr-15) mod 15))*16,14*8);
                PlaceBlock((3+((filenr-beginfilenr) div 15)*20)*8,(9+((filenr-beginfilenr) mod 15))*16,14*8);
                end
            end;

{lft}  75 : begin
            filenr:=filenr-15;
            if filenr<0 then filenr:=filenr+15;
            if ((filenr-beginfilenr)<0)then
                 begin
                 Clear;
                 holdvalue:=filenr;
                 beginfilenr:=beginfilenr-15;
                 endfilenr:=endfilenr-15;
                 filenr:=beginfilenr;
                 while (not(filenr>endfilenr) and (filenr<maxitem)) do
                  begin
                  if DirStuff^[filenr].attr=$10 then
      WrStr(4+((filenr-beginfilenr) div 15)*20,9+((filenr-beginfilenr) mod 15),'<'+DirStuff^[filenr].name+'>',203)
                  else
      WrStr(4+((filenr-beginfilenr) div 15)*20,9+((filenr-beginfilenr) mod 15),DirStuff^[filenr].name,209);
                  inc(filenr);
                  end;
                 filenr:=holdvalue;
                 PlaceBlock((3+((filenr-beginfilenr) div 15)*20)*8,(9+((filenr-beginfilenr) mod 15))*16,14*8);
                 end
            else
               begin
               EraseBlock((3+((filenr-beginfilenr+15) div 15)*20)*8,(9+((filenr-beginfilenr+15) mod 15))*16,14*8);
               PlaceBlock((3+((filenr-beginfilenr) div 15)*20)*8,(9+((filenr-beginfilenr) mod 15))*16,14*8);
               end
            end
end;
Port[968]:=200;
Port[969]:=fade;
Port[969]:=0;
Port[969]:=fade;
fade:=fade+richting;
if (fade>35) or (fade<15) then richting:=-richting;
until ((b=13) or exitthissub);
if exitthissub then goto weghieruitdezeroutine;
ThaName:=DirStuff^[filenr].Name;
b:=0;
if DirStuff^[filenr].Attr=$10 then
 if ThaName='..' then
        begin
        a:=Length(Dir)-1;
        b:=1;
        while b<>0 do
          begin
          if Dir[a]='\' then b:=0;
          dec(a);
          end;
        inc(a);
        Delete(Dir,a,Length(Dir)-a);
        b:=1;
        end
   else
      begin
      Dir:=Dir+ThaName+'\';
      b:=1;
      end;
if b=1 then goto anotherdir;
ThaName:=DirStuff^[filenr].Name;
weghieruitdezeroutine:
if exitthissub then
  GetNameFromDirectory:='Er is escape gedrukt'
else
  GetNameFromDirectory:=Dir+ThaName;
end;

{*   -------------  Read Letter -------------- *}
Procedure ReadLetter;
var name:PathStr;
    rpt,val,oldx,oldy,kleur,sc,kr:byte;
    x,y:shortint;
    esc,doe,back,starsweg:boolean;
label geenbrieflezen;

begin
name:=GetNameFromDirectory('*');
if name='Er is escape gedrukt' then goto geenbrieflezen;
Assign(Letter,name);
Reset(Letter);
{* Display writer-logo *}
DisplayWriterLogo;
{* change starfield colours to another colour *}
kr:= 63;
FOR sc := 216 TO 248 do
begin
port[968]:=sc;
port[969]:=kr;
port[969]:=kr*4 div 5;
port[969]:=0;
dec(kr);
dec(kr);
end;
Clearfield;
Bank(1);
WrStr(36,7,'+ Read +',210);

for x:=1 to 126 do
  oldcursor[x]:=0;
kleur:=215;
esc:=false;
back:=false;
starsweg:=false;
PlaceCursor(0,9);
x:=0;
y:=9;
oldx:=0;
oldy:=9;
val:=0;
while not((eof(Letter)) or (escpressed)) do
begin
 {haal karakter op}
 Read(Letter,sc,kr);
 doe:=true;
 case sc of
     59 : begin kleur:=201;doe:=false; end;    {F1 to...     }
     60 : begin kleur:=202;doe:=false; end;
     61 : begin kleur:=203;doe:=false; end;
     62 : begin kleur:=204;doe:=false; end;
     63 : begin kleur:=205;doe:=false; end;
     64 : begin kleur:=215;doe:=false; end;
     65 : begin kleur:=207;doe:=false; end;
     66 : begin kleur:=208;doe:=false; end;
     67 : begin kleur:=209;doe:=false; end;
     68 : begin kleur:=210;doe:=false; end;
     133 : begin kleur:=211;doe:=false; end;
     134 : begin kleur:=212;doe:=false; end;  { F12 ! }
     72 : begin oldy:=y;dec(y);doe:=false; end;      {pijl naar boven}
     80 : begin oldy:=y;inc(y);doe:=false; end;      {pijl naar beneden}
     75 : begin oldx:=x;dec(x);doe:=false; end;      {pijl naar links}
     77 : begin oldx:=x;inc(x);doe:=false; end;      {pijl naar rechts}
     28 : begin x:=0;inc(y);doe:=false; end; {returntoets!}
     14 : begin dec(x);kr:=32;back:=true;end;  {backspace}
      1 : begin esc:=true;doe:=false;end;
     15 : begin x:=x+5;doe:=false;end;  {tab}
     71 : begin Clear;x:=0;y:=9;doe:=false;end; {home}
 end;

 {* check borders *}
 if x>79 then begin x:=0;inc(y); end;
 if x<0 then begin x:=79;dec(y);end;
 if y>24 then begin MoveScreen1up;y:=24;oldy:=23;end;
 if y<9 then y:=9;

 {* write char *}
 if doe then wrSVGA(x,y,kr,kleur);

 {* place/erase cursor *}
 case sc of
   28,15: begin
           PlaceCursor(x,y);
           WrSVGA(oldx,oldy,32,0);
          end;
   71: PlaceCursor(x,y);
   14: begin
        PlaceCursor(x,y);
        WrSVGA(oldx,oldy,32,0);
        back:=false;
       end;
   72,80 : begin {pijl up,down}
            Putoldcursor(x,oldy);
            Getoldcursor(x,y);
            PlaceCursor(x,y);
           end;
   75,77 : begin {pijl left,right}
            Putoldcursor(oldx,oldy);
            Getoldcursor(x,y);
            PlaceCursor(x,y);
           end;
  else
    if doe then
       begin
       inc(x);
        if x>79 then
         begin
         Getoldcursor(0,y+1);
         PlaceCursor(0,y+1);
         end
        else
         begin
         Getoldcursor(x,y);
         PlaceCursor(x,y);
         end
       end
 end;

 for rpt:=0 to 4 do
   begin
   starfield;
   WaitRetrace;
    if val=4 then
       begin
       Goldflush;
       val:=0;
       end
    else
       inc(val);
   end;

 oldx:=x;
 oldy:=y;
end;
GetChar(oldx,oldy);
Close(Letter);
EraseStars;
WrStr(24,7,'End of letter. Pls press space.',210);
repeat
Getchar(sc,kr);
until kr=32;
geenbrieflezen:
end;

{* --------------    Append to a letter    ------------------*}
Procedure AppendLetter;
var name:string;
    val,oldx,oldy,kleur,sc,kr:byte;
    x,y:shortint;
    esc,doe,back,starsweg:boolean;
label geenbriefappenden;
begin
name:=GetNameFromDirectory('*');
if name='Er is escape gedrukt' then goto geenbriefappenden;
Assign(Letter,name);
Reset(Letter);
Seek(Letter, FileSize(Letter)-2);
{* Display writer-logo *}
DisplayWriterLogo;
{* change starfield colours to magenta *}
kr:= 63;
FOR sc := 216 TO 248 do
begin
port[968]:=sc;
port[969]:=kr;
port[969]:=0;
port[969]:=kr*3 div 7;
dec(kr);
dec(kr);
end;
Clearfield;
Bank(1);
WrStr(35,7,'+ Append +',210);
for x:=1 to 126 do
  oldcursor[x]:=0;
kleur:=215;
esc:=false;
back:=false;
starsweg:=false;
PlaceCursor(0,9);
x:=0;
y:=9;
oldx:=0;
oldy:=9;
repeat
{haal karakter op}
GetChar(sc,kr);
if sc>0 then
 begin
 doe:=true;
 write(Letter,sc);
 write(Letter,kr);
 end
 else doe:=false;
{zie wat karakter is en..
     check for -color codes (F1-F10)
               -return
               -gewone karakters
               -pijltestoetsen!  }
case sc of
     59 : begin kleur:=201;doe:=false; end;    {F1 to...     }
     60 : begin kleur:=202;doe:=false; end;
     61 : begin kleur:=203;doe:=false; end;
     62 : begin kleur:=204;doe:=false; end;
     63 : begin kleur:=205;doe:=false; end;
     64 : begin kleur:=215;doe:=false; end;
     65 : begin kleur:=207;doe:=false; end;
     66 : begin kleur:=208;doe:=false; end;
     67 : begin kleur:=209;doe:=false; end;
     68 : begin kleur:=210;doe:=false; end;
     133 : begin kleur:=211;doe:=false; end;
     134 : begin kleur:=212;doe:=false; end;  { F12 ! }
     72 : begin oldy:=y;dec(y);doe:=false; end;      {pijl naar boven}
     80 : begin oldy:=y;inc(y);doe:=false; end;      {pijl naar beneden}
     75 : begin oldx:=x;dec(x);doe:=false; end;      {pijl naar links}
     77 : begin oldx:=x;inc(x);doe:=false; end;      {pijl naar rechts}
     28 : begin x:=0;inc(y);doe:=false; end; {returntoets!}
     14 : begin dec(x);kr:=32;back:=true;end;  {backspace}
      1 : begin esc:=true;doe:=false;end;
     15 : begin x:=x+5;doe:=false;end;  {tab}
     71 : begin Clear;x:=0;y:=9;doe:=false;end; {home}
end;

{* check borders *}
if x>79 then begin x:=0;inc(y); end;
if x<0 then begin x:=79;dec(y);end;
if y>24 then begin MoveScreen1up;y:=24;oldy:=23;end;
if y<9 then y:=9;

{* write char *}
if doe then wrSVGA(x,y,kr,kleur);

{* place/erase cursor *}
case sc of
   28,15: begin
           PlaceCursor(x,y);
           WrSVGA(oldx,oldy,32,0);
          end;
   71: PlaceCursor(x,y);
   14: begin
        PlaceCursor(x,y);
        WrSVGA(oldx,oldy,32,0);
        back:=false;
       end;
   72,80 : begin {pijl up,down}
            Putoldcursor(x,oldy);
            Getoldcursor(x,y);
            PlaceCursor(x,y);
           end;
   75,77 : begin {pijl left,right}
            Putoldcursor(oldx,oldy);
            Getoldcursor(x,y);
            PlaceCursor(x,y);
           end;
  else
    if doe then
       begin
       inc(x);
        if x>79 then
         begin
         Getoldcursor(0,y+1);
         PlaceCursor(0,y+1);
         end
        else
         begin
         Getoldcursor(x,y);
         PlaceCursor(x,y);
         end
       end
end;

if val=4 then
  begin
  Goldflush;
  val:=0;
  end
else
  inc(val);
starfield;
WaitRetrace;
oldx:=x;
oldy:=y;
until esc;
Close(Letter);
geenbriefappenden:
end;

Procedure ChangeMusic;
var name:PathStr;
label geenmuziekveranderen;
begin
name:=GetNameFromDirectory('mod');
if name='Er is escape gedrukt' then goto geenmuziekveranderen;
case WR20_soundcard of
  2 : begin
      GP_SlideModVolTo(GP_MinVolume);
      GP_KillModule;
      GP_ResetGUS;
      GP.GUSMemProt^ := 0 ;
      GP_LoadModule(name);
      GP.GUSMemProt^ := GP.GUSMem^ ;
      GP_StartPlaying;
      GP_SlideModVolTo(GP_MaxVolume);
      end;
  1 : begin
      periodiek_off;
      einde_mod;
      Reset_Sb16;
      mod_autodetect(ON);
      laad_modbestand(name,AUTO,AUTO,22);
      periodiek_on;
      end;
end;
geenmuziekveranderen:
end;

Procedure ChangeChar;
var rechts:boolean;
begin
Clearfield;
rechts:=false;
Starfield;
item:=1;
WrStr(31,7,'* Change charset *',210);
WrStr(19,10,'Amb',209);
WrStr(17,11,'Antique',209);
WrStr(17,12,'Blocky',209);
WrStr(17,13,'Bloody',209);
WrStr(18,14,'Brush',209);
WrStr(17,15,'Chunky',209);
WrStr(16,16,'Computer',209);
WrStr(19,17,'F0',209);
WrStr(17,18,'Future',209);
WrStr(16,19,'Highseas',209);

WrStr(58,10,'King',209);
WrStr(58,11,'Kool',209);
WrStr(59,12,'LCD',209);
WrStr(57,13,'Legend',209);
WrStr(59,14,'OCR',209);
WrStr(57,15,'OldEng',209);
WrStr(57,16,'Pooter',209);
WrStr(57,17,'Runes',209);
WrStr(56,18,'Techtype',209);
WrStr(59,19,'XTC',209);

PlaceBlock(112,(9+item)*16,96);
repeat
Starfield;
WaitRetrace;
GetChar(a,b);
case a of
{dwn}  80 : Begin
             inc(item);
             if item>20 then
              item:=20
             else
              if item=11 then
                begin
                rechts:=true;
                Eraseblock(112,19*16,96);
                Placeblock(432,160,96);
                end
              else
                if rechts then
                 begin
                 Eraseblock(432,(item-2)*16,96);
                 Placeblock(432,(item-1)*16,96);
                 end
                else
                 begin
                 Eraseblock(112,(8+item)*16,96);
                 Placeblock(112,(9+item)*16,96);
                 end;
            end;
{up}   72 : Begin
             dec(item);
             if item<1 then
              item:=1
             else
              if item=10 then
                begin
                rechts:=false;
                Placeblock(112,19*16,96);
                Eraseblock(432,160,96);
                end
              else
                if rechts then
                 begin
                 Placeblock(432,(item-1)*16,96);
                 Eraseblock(432,(item)*16,96);
                 end
                else
                 begin
                 Placeblock(112,(9+item)*16,96);
                 Eraseblock(112,(10+item)*16,96);
                 end;
            end;

{lft}  75 : if rechts then
                begin
                Eraseblock(432,(item-1)*16,96);
                Item:=Item-10;
                Placeblock(112,(9+item)*16,96);
                rechts:=false;
                end;

{rght} 77 : if not(rechts) then
               begin
               Eraseblock(112,(9+item)*16,96);
               Item:=Item+10;
               Placeblock(432,(item-1)*16,96);
               rechts:=true;
               end;
end;
Port[968]:=200;
Port[969]:=fade;
Port[969]:=0;
Port[969]:=fade;
fade:=fade+richting;
if (fade>35) or (fade<15) then richting:=-richting;
until b=13;
dec(item);
l:=longint(item)*4096+1;
Seek(MyData,l);
for y:=1 to 4096 do
   begin
   Read(Mydata,a);
   Mainchar[y]:=a;
   end
end;

Procedure DosShell;
var g:string;
    e,f:byte;
    h:word;
    colours:array[0..768] of byte;
Begin
h:=0;
for e:=0 to 255 do
    begin
     Port[967]:=e;
     for f:=1 to 3 do
      begin
       colours[h]:=Port[969];
       inc(h);
      end;
    end;
asm mov ax,3; int 10h; end;
g:=GetEnv('COMSPEC');
Exec(g,' ');
asm
mov ah,4Fh
mov al,02
mov bx,100h
int 10h
end;
Port[968]:=0;
for h:=0 to 767 do
 Port[969]:=colours[h];

end;

{ *************************** Main Program ******************************* }
begin
ClrScr;
{* First detect windows and play with user if so.. *}
if windows then
     begin
     Writeln('Oops... Sorry dude(tte), I have detected Windows in memory...');
     Writeln('The program is gonna run really slow you know ! Do you really want to continue ? (y/n)');
     repeat
     Getchar(a,b);
     until ( (b=89) or (b=121) or (b=78) or (b=110) );
        if ((b=89) or (b=121)) then
            begin
            Writeln;
            Writeln('But, like.., The Writer may crash and you may loose precious data.');
            writeln('And Windows may not be able to cope and stuff.');
            writeln('Are you absolutely, positively, super-really sure of it? (y/n)');
            repeat
            Getchar(a,b);
            until ( (b=89) or (b=121) or (b=78) or (b=110) );
                if ((b=89) or (b=121)) then
                     begin
                     Writeln;
                     writeln('Naaaah!!! Windows sux! Reboot in wonderfull dos !');
                     Halt(0);
                     end;
            Halt(0);
            end
        else
            Halt(0);
     end
else
Writeln('Oh yes! You have not loaded up Windows. You are one lucky guy!');
Writeln('What sound do you have ? SoundBlaster, GUS or NoSound ? (S,G,N)');
repeat
Getchar(a,b);
until ( (b=83) or (b=71) or (b=78) or (b=115) or (b=103) or (b=110));
case b of
  83,115 : begin
           WR20_SoundCard:=1;
           SoundBlasterGekozen(True);
           if Init_the_mod then Write_sbConfig;
           Reset_Sb16;
           mod_setspeed(66);
           mod_SampleFreq(22);
           end;
  71,103 : begin
           WR20_SoundCard:=2;
           GP_ResetGUS;
           checkULTRASND;
           end;
  78,110 : WR20_SoundCard:=0;
end;
Writeln('Press spazzz');
repeat
Getchar(a,b)
until b=32;

Randomize;
for i:= 0 to 500 do
begin
xnr[i]:=round((Random(1280) - 640) * 100);
ynr[i]:=round((Random(800) - 400) * 100);
znr[i]:=round(Random(510))+1;
end;
i:=0;
while i<1002 do
begin
stuff[i]:= round((random(2560)-1280)*100);
stuff[i+1]:= round((random(1600)-800)*100);
inc(i);
inc(i);
end;
asm
mov ah,4Fh
mov al,02
mov bx,100h
int 10h
end;
New(logo);
New(DirStuff);
assign(MyData,'Datafile.wr2');
Reset(MyData);
case WR20_SoundCard of
  2 : begin
        GP.GUSMemProt^ := 0 ;
        GP_LoadModule('DATAMOD.WR2');
        GP.GUSMemProt^ := GP.GUSMem^ ;
        GP_StartPlaying;
        GP_SlideModVolTo(GP_MaxVolume) ;
      end;
  1 : begin
       richting:= laad_modbestand('Datamod.WR2',AUTO,AUTO,SamFreq);
       if richting<>0 then
           begin
           WrStr(1,1,'Error loading song!',209);
           if richting = -1 then WrStr(1,2,'File Not Found!',209);
           if richting = -2 then WrStr(1,3,'Not enough mem!',209);
           WrStr(1,4,'Press Spazz',209);
           repeat
           Getchar(a,b);
           until b=32;
           asm mov ax,3; int 10h end;
           Close(MyData);
           Halt(0);
           end;
       periodiek_on;
      end;
end;

{* Load Charset BRUSH into mainchar *}
l:=4*4096;
Seek(MyData,l);
for x:=1 to 4096 do
    begin
    Read(MyData,a);
    Mainchar[x]:=a;
    end;
 {--- Copy first 16 colors to position 200-216 ---}
  a:=200;
  for c:=0 to 15 do
  begin
  Port[967]:=c;
  r:=Port[969];
  g:=Port[969];
  b:=Port[969];
  Port[968]:=a;
  port[969]:=r;
  port[969]:=g;
  port[969]:=b;
  inc(a);
  end;
 {--- colourblock ---}
  port[968]:=200;
  port[969]:=10;
  port[969]:=0;
  port[969]:=10;
 {--- CURSOR gold ---}
 Port[968]:=249;
 Port[969]:=60;
 Port[969]:=60;
 Port[969]:=40;

 Port[968]:=250;
 Port[969]:=52;
 Port[969]:=52;
 Port[969]:=32;

 Port[968]:=251;
 Port[969]:=48;
 Port[969]:=44;
 Port[969]:=24;

 Port[968]:=252;
 Port[969]:=40;
 Port[969]:=36;
 Port[969]:=16;

 Port[968]:=253;
 Port[969]:=36;
 Port[969]:=28;
 Port[969]:=8;

 Port[968]:=254;
 Port[969]:=28;
 Port[969]:=20;
 Port[969]:=4;

 Port[968]:=255;
 Port[969]:=7;
 Port[969]:=5;
 Port[969]:=0;
{* Main init, for recall... and startup *}
init:
item:=1;
ClsSVGA;
{* Init all colors *}
 {--- Logo ---}
  l:=20*4096;
  Seek(MyData,l);
  Port[968]:=0;
  for x:=1 to 600 do
      begin
      Read(MyData,a);
      Port[969]:=a;
      end;
 {--- Starfield ---}
  a:= 63;
  FOR c := 216 TO 248 do
  begin
  port[968]:=c;
  port[969]:=0;
  port[969]:=a;
  port[969]:=a;
  dec(a);
  dec(a);
  end;
{* Load Menulogo into mem-heap *}
l:=(20*4096)+768;
Seek(MyData,l);
for y:=1 to 64000 do
    begin
    Read(MyData,a);
    logo^[y]:=a;
    end;
{* Display logo on screen *}
Bank(0);
for y:=1 to 64000 do
    mem[$0A000:y-1]:=logo^[y];
{* Display menu * }
Bank(1);
WrStr(35,7,'+ Menu +',215);
WrStr(34,12,'Make a letter',215);
WrStr(34,13,'Read a letter',215);
WrStr(31,14,'Append to a letter',215);
WrStr(34,15,'Change Music',215);
WrStr(33,16,'Change Charset',215);
WrStr(36,17,'DOS-Shell',215);
WrStr(34,18,'Exit program',215);

Placeblock(232,192,176);
richting:=1;
fade:=15;
repeat
Starfield;
WaitRetrace;
GetChar(a,b);
case a of
     80 : begin
           inc(item);
           if item>7 then
             item:=7
           else
             begin
             Placeblock(232,(11+item)*16,176);
             Eraseblock(232,(10+item)*16,176);
             end
          end;
     72 : begin
           dec(item);
           if item<1 then
             item:=1
           else
             begin
             Placeblock(232,(11+item)*16,176);
             Eraseblock(232,(12+item)*16,176);
             end
          end;
end;
Port[968]:=200;
Port[969]:=fade;
Port[969]:=0;
Port[969]:=fade;
fade:=fade+richting;
if (fade>35) or (fade<15) then richting:=-richting;
until b=13;
case item of
    1: MakeLetter;
    2: ReadLetter;
    3: AppendLetter;
    4: ChangeMusic;
    5: ChangeChar;
    6: DosShell;
    7: Stop:=true;
end;
if stop then goto endproggy;
goto init;


endproggy:
case WR20_SoundCard of
  2 : begin
      GP_SlideModVolTo(GP_MinVolume) ;
      GP_KillModule;
      GP_ResetGUS;
      end;
  1 : begin
      outfading:=true;
      repeat until outvolume<1;
      periodiek_off;
      einde_mod;
      Reset_sb16;
      end;
end;
Dispose(DirStuff);
Dispose(Logo);
Close(MyData);
asm
mov ax,0003h
int 10h
end;
Writeln('The Writer V2.0bta build 1.00.21');
Writeln('A Freedom Systems 1998 production.');
end.
