(*   {$M 4000,0,0}	(*  This keeps the compiler from allocating heap memory!! *)
(*   {$A+,G+}		(*  286 instructions, and word alignment.. *)
{$G+,I-,X+,A+,N+}
{$M 16768,0,180000}
program GusTest ;
uses dos,crt, GP15;
var modfilename,
	sndfilename : string ;
	sndpointer	: pointer ;
	sndhandle	: word ;
	sndsize		: word ;
	nexttime	: longint ;

begin
	writeln('This is a test.') ;
	writeln('To run this you need to know these things:') ;
	writeln('   1. The path to a .MOD file you would like played (module).') ;
	writeln('   2. The path to an 8 bit .SND file you would like played.') ;
	writeln('And.. if your GUS isn''t using the default base address (220h)') ;
	writeln('you should make sure your ULTRASND environment variable is') ;
	writeln('set up properly.  Also make sure you have enuff GUS DRAM for') ;
	writeln('both the .SND file and the module''s samples AT ONCE.') ;
	writeln ;
	writeln('Press ENTER if everything is ok, anything else to try again later.') ;
	if (readkey <> #13) then halt(0) ;
	writeln('OK!  Here we go..') ;
	writeln('Give me the path to a .MOD file (f.ex. "c:\misc\modules\trance.mod")') ;
	write('-> ') ;
	readln(modfilename) ;
	writeln('Ok, now this program SHOULD play back the .MOD file, and also') ;
	writeln('the .SND file, once every 2 seconds (after showing off a little).') ;
	GP_ResetGUS ;

	if readkey = #0 then if readkey = #0 then ;

	writeln ;
	Writeln('That was fun!  Now lets do some module stuff..') ;

	GP_LoadModule(modfilename) ;
	GP_StartPlaying ;

	delay(500) ;
	writeln('Volume goes down..') ;

	delay(1000) ;
	writeln('Volume goes up..') ;
    GP_SlideModVolTo(GP_MaxVolume) ;

	writeln ;
	writeln('Now, lets get some status reports, and play with our .SND') ;
	writeln('file again.  And lets turn down the volume.') ;
	writeln ;
	delay(1000) ;

    GP_SlideModVolTo(GP_MidVolume div 2) ;      (* 1/4 volume = 16 *)
	delay(1000) ;

	nexttime := 0 ;
	repeat
		if (GP.Timer^ > nexttime) then begin
			nexttime := GP.Timer^+2000 ;
		end ;
		gotoxy(1,WhereY) ;
		write('Position: ',	GP.Vars^[PlayingPattern]:3,
						'/',GP.Vars^[PatternRow]:2,'  ') ;
		write('Timer: ',GP.Timer^:8) ;
		write('  Next .SND voice: ', GP.Vars^[NextVoice]:2) ;
	until keypressed ;

	if readkey = #0 then if readkey = #0 then ;

	writeln ;
	writeln ;
    writeln('Thats it!  Now go read the dox (if you haven''t already).') ;

	GP_KillModule ;
	GP_ResetGUS ;
end.
