.386
.MODEL TPascal
  b equ byte ptr
  w equ word ptr
  d equ dword ptr


.DATA

extrn actuele_stem     : word;
extrn calc_size           : word;
extrn Mixed_data          : dword;
extrn Mixed_posi          : word;
extrn Mixed_data_st       : dword;

extrn Mixingprocs         : dword;
extrn Stemleeg          : dword;

extrn Lengte_stem       : dword
extrn Positie_stem     : dword
extrn Loop_Lengte_stem  : dword
extrn Loop_Start_stem   : dword
extrn Segment_stem      : dword
extrn Nootvol_stem       : dword
extrn Incval_stem       : dword


.CODE


public stem_normaal
stem_normaal proc pascal ;actuele_stem : word;
 pusha
 mov si,actuele_stem
 dec si
 shl si,2                    ; tbv dword-access

 mov cx,calc_size

@Laad_loop:

;{ stem is afgelopen ? }
  mov bx,w Lengte_stem[si]
  sub bx,20
  cmp bx,word ptr Positie_stem[si+2]
  ja  @Stem_niet_aan_einde

;{ Stem afgelopen. Geloopt ? }
  cmp Loop_Lengte_stem[si],10
  jae @Stem_is_geloopt

;{Stem afgelopen en niet geloopt => afsluiten}
  mov eax,stemleeg
  mov Mixingprocs[si],eax
  mov Nootvol_stem[si],0
  jmp @einde_stem_normal

; {Parameters voor stem1 naar begin van de loop }
@Stem_is_geloopt:
  mov bx,w Loop_Start_stem[si]
  mov word ptr Positie_stem[si + 2],bx

; {Byte uit sample voor stem1 laden }
@Stem_niet_aan_einde:
  mov bx,w Segment_stem[si]
  mov es,bx
  mov bx,word ptr Positie_stem[si + 2]
  mov al,es:[bx]
  sub al,128
  mul b Nootvol_stem[si]
  shr ax,6

@Stem_weergeven:
  les di,mixed_data
  add di,mixed_posi
  add es:[di],ax
  add mixed_posi,2

; {pointer verplaatsen}
  mov ebx,Incval_stem[si]
  add dword ptr Positie_stem[si],ebx

  loop @Laad_loop

@einde_stem_normal:
  popa
  ret
stem_normaal endp



public stem_normaal_st
stem_normaal_st proc pascal ;actuele_stem : word;
 pusha
 mov si,actuele_stem
 dec si
 shl si,2                    ; tbv dword-access

 mov cx,calc_size

@Laad_loop_st:

;{ Stem afgelopen ? }
  mov bx,w Lengte_stem[si]
  sub bx,20
  cmp bx,word ptr Positie_stem[si+2]
  ja  @Stem_niet_aan_einde_st

;{ Stem afgelopen. Geloopt ? }
  cmp Loop_Lengte_stem[si],10
  jae @Stem_is_geloopt_st

;{Stem is afgelopen en niet geloopt => afsluiten}
  mov eax,stemleeg
  mov Mixingprocs[si],eax
  mov ax,127
  mov Nootvol_stem[si],0
  jmp @einde_stem_normal_st

; {Parameters voor stem1 naar begin van de loop }
@Stem_is_geloopt_st:
  mov bx,w Loop_Start_stem[si]
  mov word ptr Positie_stem[si + 2],bx

; {Byte uit sample van stem1 laden }
@Stem_niet_aan_einde_st:
  mov bx,w Segment_stem[si]
  mov es,bx
  mov bx,word ptr Positie_stem[si + 2]
  mov al,es:[bx]
  sub al,128
  mul b Nootvol_stem[si]
  shr ax,6

@Stem_weergeven_st:
  les di,mixed_data_st
  add di,mixed_posi
  add es:[di],ax
  add mixed_posi,2

; {pointer verplaatsen}
  mov ebx,Incval_stem[si]
  add dword ptr Positie_stem[si],ebx

  loop @Laad_loop_st

@einde_stem_normal_st:
  popa
  ret
stem_normaal_st endp






public Lege_stem
Lege_stem proc pascal
  ret
Lege_stem endp

END
